// WL_MAIN.C

#include <conio.h>
#include "WL_DEF.H"
#pragma hdrstop


/*
=============================================================================

						   WOLFENSTEIN 3-D

					  An Id Software production

						   by John Carmack

=============================================================================
*/

/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/


#define FOCALLENGTH     (0x5700l)               // in global coordinates
#define VIEWGLOBAL      0x10000                 // globals visable flush to wall

#define VIEWWIDTH       256                     // size of view window
#define VIEWHEIGHT      144

/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/

char            str[80],str2[20];
int				tedlevelnum;
boolean         tedlevel;
boolean         nospr;
boolean         IsA386;
int                     dirangle[9] = {0,ANGLES/8,2*ANGLES/8,3*ANGLES/8,4*ANGLES/8,
	5*ANGLES/8,6*ANGLES/8,7*ANGLES/8,ANGLES};

//
// proejection variables
//
fixed           focallength;
unsigned        screenofs;
int             viewwidth;
int             viewheight;
int             centerx;
int             shootdelta;                     // pixels away from centerx a target can be
fixed           scale,maxslope;
long            heightnumerator;
int                     minheightdiv;


void            Quit (char *error);

boolean         startgame,loadedgame,virtualreality;
int             mouseadjustment;

char	configname[13]="CONFIG.";
char	gamename[13]="GAME.WL6";


/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/

/*
====================
=
= ReadGame
=
====================
*/

void ReadGame(void)
{
	int        file;

	if ( (file = open(gamename,O_BINARY | O_RDONLY)) != -1)
	{
	//
	// valid game control file
	//
		read(file,&seamlessness,sizeof(seamlessness));
		read(file,&seamlesslevels,sizeof(seamlesslevels));
		read(file,&weaptics,sizeof(weaptics));
		read(file,&weapattack,sizeof(weapattack));
		read(file,&weapframe,sizeof(weapframe));
		read(file,&higherweap,sizeof(higherweap));
		read(file,&ammonum,sizeof(ammonum));
		read(file,&ammotype,sizeof(ammotype));
		read(file,&weapenab,sizeof(weapenab));
		read(file,&weapstar,sizeof(weapstar));
		read(file,&starbest,sizeof(starbest));
		read(file,&ammomax,sizeof(ammomax));
		read(file,&ammostar,sizeof(ammostar));
		read(file,&weapimage,sizeof(weapimage));
		read(file,&weapaccur,sizeof(weapaccur));
		read(file,&weapdamag,sizeof(weapdamag));
		read(file,&weapsound,sizeof(weapsound));
		read(file,&weapkick,sizeof(weapkick));
		read(file,&weaprange,sizeof(weaprange));
		read(file,&silenced,sizeof(silenced));
		read(file,&weapimage,sizeof(weapimage));
		read(file,&damanoise,sizeof(damanoise));
		//read(file,&episode1tit,sizeof(episode1tit));
		//read(file,&episode1nam,sizeof(episode1nam));
		//read(file,&episode2tit,sizeof(episode2tit));
		//read(file,&episode2nam,sizeof(episode2nam));
		//read(file,&episode3tit,sizeof(episode3tit));
		//read(file,&episode3nam,sizeof(episode3nam));
		//read(file,&episode4tit,sizeof(episode4tit));
		//read(file,&episode4nam,sizeof(episode4nam));
		//read(file,&episode5tit,sizeof(episode5tit));
		//read(file,&episode5nam,sizeof(episode5nam));
		//read(file,&episode6tit,sizeof(episode6tit));
		//read(file,&episode6nam,sizeof(episode6nam));
		read(file,&piercing,sizeof(piercing));
		read(file,&misssped,sizeof(misssped));
		read(file,&firesped,sizeof(firesped));
		read(file,&missboom,sizeof(missboom));
		read(file,&fireboom,sizeof(fireboom));
		read(file,&missnorm,sizeof(misssped));
		read(file,&firenorm,sizeof(firenorm));
		read(file,&missplus,sizeof(missplus));
		read(file,&fireplus,sizeof(fireplus));
		read(file,&misssoun,sizeof(misssoun));
		read(file,&firesoun,sizeof(firesoun));
		read(file,&missexpl,sizeof(missexpl));
		read(file,&fireexpl,sizeof(fireexpl));
		read(file,&highres,sizeof(highres));
	      /*read(file,&weaptics[0],sizeof(weaptics[0]));
		read(file,&weaptics[1],sizeof(weaptics[1]));
		read(file,&weaptics[2],sizeof(weaptics[2]));
		read(file,&weaptics[3],sizeof(weaptics[3]));
		read(file,&weaptics[4],sizeof(weaptics[4]));
		read(file,&weaptics[5],sizeof(weaptics[5]));
		read(file,&weaptics[6],sizeof(weaptics[6]));
		read(file,&weaptics[7],sizeof(weaptics[7]));
		read(file,&weaptics[8],sizeof(weaptics[8]));
		read(file,&weaptics[9],sizeof(weaptics[9]));
		read(file,&weaptics[10],sizeof(weaptics[10]));
		read(file,&weaptics[11],sizeof(weaptics[11]));
		read(file,&weaptics[12],sizeof(weaptics[12]));
		read(file,&weaptics[13],sizeof(weaptics[13]));
		read(file,&weaptics[14],sizeof(weaptics[14]));
		read(file,&weaptics[15],sizeof(weaptics[15]));
		read(file,&weapattack[0],sizeof(weapattack[0]));
		read(file,&weapattack[1],sizeof(weapattack[1]));
		read(file,&weapattack[2],sizeof(weapattack[2]));
		read(file,&weapattack[3],sizeof(weapattack[3]));
		read(file,&weapattack[4],sizeof(weapattack[4]));
		read(file,&weapattack[5],sizeof(weapattack[5]));
		read(file,&weapattack[6],sizeof(weapattack[6]));
		read(file,&weapattack[7],sizeof(weapattack[7]));
		read(file,&weapattack[8],sizeof(weapattack[8]));
		read(file,&weapattack[9],sizeof(weapattack[9]));
		read(file,&weapattack[10],sizeof(weapattack[10]));
		read(file,&weapattack[11],sizeof(weapattack[11]));
		read(file,&weapattack[12],sizeof(weapattack[12]));
		read(file,&weapattack[13],sizeof(weapattack[13]));
		read(file,&weapattack[14],sizeof(weapattack[14]));
		read(file,&weapattack[15],sizeof(weapattack[15]));
		read(file,&weapframe[0],sizeof(weapframe[0]));
		read(file,&weapframe[1],sizeof(weapframe[1]));
		read(file,&weapframe[2],sizeof(weapframe[2]));
		read(file,&weapframe[3],sizeof(weapframe[3]));
		read(file,&weapframe[4],sizeof(weapframe[4]));
		read(file,&weapframe[5],sizeof(weapframe[5]));
		read(file,&weapframe[6],sizeof(weapframe[6]));
		read(file,&weapframe[7],sizeof(weapframe[7]));
		read(file,&weapframe[8],sizeof(weapframe[8]));
		read(file,&weapframe[9],sizeof(weapframe[9]));
		read(file,&weapframe[10],sizeof(weapframe[10]));
		read(file,&weapframe[11],sizeof(weapframe[11]));
		read(file,&weapframe[12],sizeof(weapframe[12]));
		read(file,&weapframe[13],sizeof(weapframe[13]));
		read(file,&weapframe[14],sizeof(weapframe[14]));
		read(file,&weapframe[15],sizeof(weapframe[15]));*/
	  /*read(file,&weapframe1,sizeof(weapframe1));
		read(file,&weapframe2,sizeof(weapframe2));
		read(file,&weapframe3,sizeof(weapframe3));
		read(file,&weapframe4,sizeof(weapframe4));
		read(file,&weapframe5,sizeof(weapframe5));
		read(file,&weapframe6,sizeof(weapframe6));
		read(file,&weapframe7,sizeof(weapframe7));
		read(file,&weapframe8,sizeof(weapframe8));
		read(file,&weapframe9,sizeof(weapframe9));
		read(file,&weapframe10,sizeof(weapframe10));
		read(file,&weapframe11,sizeof(weapframe11));
		read(file,&weapframe12,sizeof(weapframe12));
		read(file,&weapframe13,sizeof(weapframe13));
		read(file,&weapframe14,sizeof(weapframe14));
		read(file,&weapframe15,sizeof(weapframe15));
		read(file,&weapframe16,sizeof(weapframe16));
		read(file,&weap1power,sizeof(weap1power));
		read(file,&weap2power,sizeof(weap2power));
		read(file,&weap3power,sizeof(weap3power));
		read(file,&weap4power,sizeof(weap4power));
		read(file,&maxammo1,sizeof(maxammo1));
		read(file,&startammo1,sizeof(startammo1));
		read(file,&maxhealth,sizeof(maxhealth));
		read(file,&guardhp1,sizeof(guardhp1));
		read(file,&guardhp2,sizeof(guardhp2));
		read(file,&guardhp3,sizeof(guardhp3));
		read(file,&guardhp4,sizeof(guardhp4));
		read(file,&guardspeed,sizeof(guardspeed));
		read(file,&guardpain,sizeof(guardpain));
		read(file,&guardacc,sizeof(guardacc));
		read(file,&guarddamage,sizeof(guarddamage));
		read(file,&guardpoints,sizeof(guardpoints));
		read(file,&sshp1,sizeof(sshp1));
		read(file,&sshp2,sizeof(sshp2));
		read(file,&sshp3,sizeof(sshp3));
		read(file,&sshp4,sizeof(sshp4));
		read(file,&ssspeed,sizeof(ssspeed));
		read(file,&sspain,sizeof(sspain));
		read(file,&ssacc,sizeof(ssacc));
		read(file,&ssdamage,sizeof(ssdamage));
		read(file,&sspoints,sizeof(sspoints));
		read(file,&officerhp1,sizeof(officerhp1));
		read(file,&officerhp2,sizeof(officerhp2));
		read(file,&officerhp3,sizeof(officerhp3));
		read(file,&officerhp4,sizeof(officerhp4));
		read(file,&officerspeed,sizeof(officerspeed));
		read(file,&officerpain,sizeof(officerpain));
		read(file,&officeracc,sizeof(officeracc));
		read(file,&officerdamage,sizeof(officerdamage));
		read(file,&officerpoints,sizeof(officerpoints));
		read(file,&doghp1,sizeof(doghp1));
		read(file,&doghp2,sizeof(doghp2));
		read(file,&doghp3,sizeof(doghp3));
		read(file,&doghp4,sizeof(doghp4));
		read(file,&dogspeed,sizeof(dogspeed));
		read(file,&dogacc,sizeof(dogacc));
		read(file,&dogdamage,sizeof(dogdamage));
		read(file,&dogpoints,sizeof(dogpoints));
		read(file,&mutanthp1,sizeof(mutanthp1));
		read(file,&mutanthp2,sizeof(mutanthp2));
		read(file,&mutanthp3,sizeof(mutanthp3));
		read(file,&mutanthp4,sizeof(mutanthp4));
		read(file,&mutantspeed,sizeof(mutantspeed));
		read(file,&mutantpain,sizeof(mutantpain));
		read(file,&mutantacc,sizeof(mutantacc));
		read(file,&mutantdamage,sizeof(mutantdamage));
		read(file,&mutantpoints,sizeof(mutantpoints));
		read(file,&hanshp1,sizeof(hanshp1));
		read(file,&hanshp2,sizeof(hanshp2));
		read(file,&hanshp3,sizeof(hanshp3));
		read(file,&hanshp4,sizeof(hanshp4));
		read(file,&hansspeed,sizeof(hansspeed));
		read(file,&hansacc,sizeof(hansacc));
		read(file,&hansdamage,sizeof(hansdamage));
		read(file,&hanspoints,sizeof(hanspoints));
		read(file,&schabbshp1,sizeof(schabbshp1));
		read(file,&schabbshp2,sizeof(schabbshp2));
		read(file,&schabbshp3,sizeof(schabbshp3));
		read(file,&schabbshp4,sizeof(schabbshp4));
		read(file,&schabbsspeed,sizeof(schabbsspeed));
		read(file,&schabbsacc,sizeof(schabbsacc));
		read(file,&schabbsdamage,sizeof(schabbsdamage));
		read(file,&schabbspoints,sizeof(schabbspoints));
		read(file,&fakehp1,sizeof(fakehp1));
		read(file,&fakehp2,sizeof(fakehp2));
		read(file,&fakehp3,sizeof(fakehp3));
		read(file,&fakehp4,sizeof(fakehp4));
		read(file,&fakespeed,sizeof(fakespeed));
		read(file,&fakeacc,sizeof(fakeacc));
		read(file,&fakedamage,sizeof(fakedamage));
		read(file,&fakepoints,sizeof(fakepoints));
		read(file,&mechahp1,sizeof(mechahp1));
		read(file,&mechahp2,sizeof(mechahp2));
		read(file,&mechahp3,sizeof(mechahp3));
		read(file,&mechahp4,sizeof(mechahp4));
		read(file,&mechaspeed,sizeof(mechaspeed));
		read(file,&mechaacc,sizeof(mechaacc));
		read(file,&mechadamage,sizeof(mechadamage));
		read(file,&mechapoints,sizeof(mechapoints));
		read(file,&hitlerhp1,sizeof(hitlerhp1));
		read(file,&hitlerhp2,sizeof(hitlerhp2));
		read(file,&hitlerhp3,sizeof(hitlerhp3));
		read(file,&hitlerhp4,sizeof(hitlerhp4));
		read(file,&hitlerspeed,sizeof(hitlerspeed));
		read(file,&hitleracc,sizeof(hitleracc));
		read(file,&hitlerdamage,sizeof(hitlerdamage));
		read(file,&hitlerpoints,sizeof(hitlerpoints));
		read(file,&gifthp1,sizeof(gifthp1));
		read(file,&gifthp2,sizeof(gifthp2));
		read(file,&gifthp3,sizeof(gifthp3));
		read(file,&gifthp4,sizeof(gifthp4));
		read(file,&giftspeed,sizeof(giftspeed));
		read(file,&giftacc,sizeof(giftacc));
		read(file,&giftdamage,sizeof(giftdamage));
		read(file,&giftpoints,sizeof(giftpoints));
		read(file,&gretelhp1,sizeof(gretelhp1));
		read(file,&gretelhp2,sizeof(gretelhp2));
		read(file,&gretelhp3,sizeof(gretelhp3));
		read(file,&gretelhp4,sizeof(gretelhp4));
		read(file,&gretelspeed,sizeof(gretelspeed));
		read(file,&gretelacc,sizeof(gretelacc));
		read(file,&greteldamage,sizeof(greteldamage));
		read(file,&gretelpoints,sizeof(gretelpoints));
		read(file,&fathp1,sizeof(fathp1));
		read(file,&fathp2,sizeof(fathp2));
		read(file,&fathp3,sizeof(fathp3));
		read(file,&fathp4,sizeof(fathp4));
		read(file,&fatspeed,sizeof(fatspeed));
		read(file,&fatacc,sizeof(fatacc));
		read(file,&fatdamage,sizeof(fatdamage));
		read(file,&fatpoints,sizeof(fatpoints));*/

		close(file);

	}
	else
	{
	//
	// no control file, so generate to original wolf
	//
	  /*weapframe1 = weapframe2 = weapframe3 = weapframe4 =
		weapframe5 = weapframe6 = weapframe7 = weapframe8 =
		weapframe9 = weapframe10 = weapframe11 = weapframe12 =
		weapframe13 = weapframe14 = weapframe15 = weapframe16 = 6;

		weap1power = weap2power = weap3power = weap4power = 100;

		maxammo1 = 99;
		startammo1 = 8;
		maxhealth = 100;

		guardhp1 = 25;
		guardhp2 = 25;
		guardhp3 = 25;
		guardhp4 = 25;
		guardspeed = 3;
		guardpain = 256;
		guardacc = 12;
		guarddamage = 100;
		guardpoints = 100;

		sshp1 = 100;
		sshp2 = 100;
		sshp3 = 100;
		sshp4 = 100;
		ssspeed = 4;
		sspain = 256;
		ssacc = 8;
		ssdamage = 100;
		sspoints = 500;

		officerhp1 = 50;
		officerhp2 = 50;
		officerhp3 = 50;
		officerhp4 = 50;
		officerspeed = 5;
		officerpain = 256;
		officeracc = 12;
		officerdamage = 100;
		officerpoints = 400;

		doghp1 = 1;
		doghp2 = 1;
		doghp3 = 1;
		doghp4 = 1;
		dogspeed = 2;
		dogacc = 12;
		dogdamage = 100;
		dogpoints = 200;

		mutanthp1 = 45;
		mutanthp2 = 55;
		mutanthp3 = 55;
		mutanthp4 = 65;
		mutantspeed = 3;
		mutantpain = 256;
		mutantacc = 12;
		mutantdamage = 100;
		mutantpoints = 700;

		hanshp1 = 850;
		hanshp2 = 950;
		hanshp3 = 1050;
		hanshp4 = 1200;
		hansspeed = 3;
		hansacc = 8;
		hansdamage = 100;
		hanspoints = 5000;

		schabbshp1 = 850;
		schabbshp2 = 950;
		schabbshp3 = 1550;
		schabbshp4 = 2400;
		schabbsspeed = 3;
		schabbsacc = 12;
		schabbsdamage = 100;
		schabbspoints = 5000;

		fakehp1 = 200;
		fakehp2 = 300;
		fakehp3 = 400;
		fakehp4 = 500;
		fakespeed = 3;
		fakeacc = 12;
		fakedamage = 100;
		fakepoints = 2000;

		mechahp1 = 800;
		mechahp2 = 950;
		mechahp3 = 1050;
		mechahp4 = 1200;
		mechaspeed = 3;
		mechaacc = 12;
		mechadamage = 100;
		mechapoints = 5000;

		hitlerhp1 = 500;
		hitlerhp2 = 700;
		hitlerhp3 = 800;
		hitlerhp4 = 900;
		hitlerspeed = 5;
		hitleracc = 12;
		hitlerdamage = 100;
		hitlerpoints = 5000;

		gifthp1 = 850;
		gifthp2 = 950;
		gifthp3 = 1050;
		gifthp4 = 1200;
		giftspeed = 3;
		giftacc = 12;
		giftdamage = 100;
		giftpoints = 5000;

		gretelhp1 = 850;
		gretelhp2 = 950;
		gretelhp3 = 1050;
		gretelhp4 = 1200;
		gretelspeed = 3;
		gretelacc = 12;
		greteldamage = 100;
		gretelpoints = 5000;

		fathp1 = 850;
		fathp2 = 950;
		fathp3 = 1050;
		fathp4 = 1200;
		fatspeed = 3;
		fatacc = 12;
		fatdamage = 100;
		fatpoints = 5000;*/
		seamlessness = false;
		seamlesslevels = 60;
		weaptics[0] = weaptics[1] = weaptics[2] = weaptics[3] =
		weaptics[4] = weaptics[5] = weaptics[6] = weaptics[7] =
		weaptics[8] = weaptics[9] = weaptics[10] = weaptics[11] =
		weaptics[12] = weaptics[13] = weaptics[14] = weaptics[15] =
		weaptics[16] = weaptics[17] = weaptics[18] = weaptics[19] =
		weaptics[20] = weaptics[21] = weaptics[22] = weaptics[23] =
		weaptics[24] = weaptics[25] = weaptics[26] = weaptics[27] =
		weaptics[28] = weaptics[29] = weaptics[30] = weaptics[31] =
		weaptics[32] = weaptics[33] = weaptics[34] = weaptics[35] =
		weaptics[36] = weaptics[37] = weaptics[38] = weaptics[39] = 6;

		weapattack[3] = weapattack[7] = weapattack[11] =
		weapattack[15] = weapattack[19] = weapattack[23] =
		weapattack[27] = weapattack[31] = weapattack[35] =
		weapattack[39] = 20;
		weapattack[0] = weapattack[2] = weapattack[4] =
		weapattack[6] = weapattack[8] = weapattack[12] =
		weapattack[18] = weapattack[22] =
		weapattack[26] = weapattack[30] = weapattack[34] =
		weapattack[38] =
		weapattack[16] = weapattack[20] =
		weapattack[24] = weapattack[28] = weapattack[32] =
		weapattack[36] = 0;
		weapattack[5] = weapattack[9] = weapattack[13] =
		weapattack[17] = weapattack[21] =
		weapattack[25] = weapattack[29] = weapattack[33] =
		weapattack[37] = 1;
		weapattack[1] = 2;
		weapattack[10] = 3;
		weapattack[14] = 4;
		weapframe[0] = weapframe[4] = weapframe[8] =
		weapframe[12] = 1;
		weapframe[1] = weapframe[5] = weapframe[9] =
		weapframe[13] = 2;
		weapframe[2] = weapframe[6] = weapframe[10] =
		weapframe[14] = 3;
		weapframe[3] = weapframe[7] = weapframe[11] =
		weapframe[15] = 4;
		higherweap = false;
		ammonum[0] = ammonum[1] = ammonum[2] = ammonum[3] =
		ammonum[4] = ammonum[5] = ammonum[6] = ammonum[7] =
		ammonum[8] = ammonum[9] = 6;
		ammotype[0] = 0;
		ammotype[1] = ammotype[2] = ammotype[3] =
		ammotype[4] = ammotype[5] = ammotype[6] = ammotype[7] =
		ammotype[8] = ammotype[9] = 1;
		weapenab[0] = weapenab[1] = weapenab[2] = weapenab[3] =
		true;
		weapenab[4] = weapenab[5] = weapenab[6] = weapenab[7] =
		weapenab[8] = weapenab[9] = false;
		weapstar[0] = weapstar[1] = true;
		weapstar[2] = weapstar[3] = weapstar[4] = weapstar[5] =
		weapstar[6] = weapstar[7] = weapstar[8] = weapstar[9] =
		false;
		starbest = 1;
		ammomax[0] = 1;
		ammostar[0] = 1;
		ammomax[1] = 99;
		ammostar[1] = 8;
		ammomax[2] = 0;
		ammostar[2] = 0;
		ammomax[3] = 0;
		ammostar[3] = 0;
		ammomax[4] = 0;
		ammostar[4] = 0;
		ammomax[5] = 0;
		ammostar[5] = 0;
		ammomax[6] = 0;
		ammostar[6] = 0;
		ammomax[7] = 0;
		ammostar[7] = 0;
		ammomax[8] = 0;
		ammostar[8] = 0;
		ammomax[9] = 0;
		ammostar[9] = 0;
		weapimage[0] = 88;
		weapimage[1] = 89;
		weapimage[2] = 90;
		weapimage[3] = weapimage[4] = weapimage[5] =
		weapimage[6] = weapimage[7] = weapimage[8] =
		weapimage[9] = 91;
		weapaccur[0] = weapaccur[1] = weapaccur[2] =
		weapaccur[3] = weapaccur[4] = weapaccur[5] =
		weapaccur[6] = weapaccur[7] = weapaccur[8] =
		weapaccur[9] = 100;
		weapdamag[0] = weapdamag[1] = weapdamag[2] =
		weapdamag[3] = weapdamag[4] = weapdamag[5] =
		weapdamag[6] = weapdamag[7] = weapdamag[8] =
		weapdamag[9] = 100;
		weapsound[0] = 23;
		weapsound[1] = 24;
		weapsound[2] = 26;
		weapsound[3] = weapsound[4] = weapsound[5] =
		weapsound[6] = weapsound[7] = weapsound[8] =
		weapsound[9] = 11;
		weapkick[0] = weapkick[1] = weapkick[2] =
		weapkick[3] = weapkick[4] = weapkick[0] =
		weapkick[6] = weapkick[7] = weapkick[8] =
		weapkick[9] = 0;
		weaprange[0] = weaprange[1] = weaprange[2] =
		weaprange[3] = weaprange[4] = weaprange[5] =
		weaprange[6] = weaprange[7] = weaprange[8] =
		weaprange[9] = 120;
		silenced[0] = true;
		silenced[1] = silenced[2] = silenced[3] =
		silenced[4] = silenced[5] = silenced[5] =
		silenced[7] = silenced[8] = silenced[9] = false;
		damanoise = true;
		//episode1tit[] = "Episode 1";
		//episode1nam[] = "Escape from Wolfenstein";
		//episode2tit[] = "Episode 2";
		//episode2nam[] = "Operation: Eisenfaust";
		//episode3tit[] = "Episode 3";
		//episode3nam[] = "Die, Fuhrer, Die!";
		//episode4tit[] = "Episode 4";
		//episode4nam[] = "A Dark Secret";
		//episode5tit[] = "Episode 5";
		//episode5nam[] = "Trail of the Madman";
		//episode6tit[] = "Episode 6";
		//episode6nam[] = "Confrontation";
		piercing[0] = piercing[1] = piercing[2] =
		piercing[3] = piercing[4] = piercing[5] =
		piercing[6] = piercing[7] = piercing[8] =
		piercing[9] = false;
		misssped = 20;
		firesped = 12;
                missboom = false;
		fireboom = false;
		missnorm = 2;
		firenorm = 10;
		missplus = 40;
		fireplus = 10;
		misssoun = 86;
		firesoun = 0;
		missexpl = 300;
                fireexpl = 50;
		highres[0] = highres[1] = highres[2] =
		highres[3] = highres[4] = highres[5] =
		highres[6] = highres[7] = highres[8] =
		highres[9] = false;


		file = creat(gamename,S_IREAD | S_IWRITE);

		if (file != -1)
		{
	  /*write(file,&weapframe1,sizeof(weapframe1));
		write(file,&weapframe2,sizeof(weapframe2));
		write(file,&weapframe3,sizeof(weapframe3));
		write(file,&weapframe4,sizeof(weapframe4));
		write(file,&weapframe5,sizeof(weapframe5));
		write(file,&weapframe6,sizeof(weapframe6));
		write(file,&weapframe7,sizeof(weapframe7));
		write(file,&weapframe8,sizeof(weapframe8));
		write(file,&weapframe9,sizeof(weapframe9));
		write(file,&weapframe10,sizeof(weapframe10));
		write(file,&weapframe11,sizeof(weapframe11));
		write(file,&weapframe12,sizeof(weapframe12));
		write(file,&weapframe13,sizeof(weapframe13));
		write(file,&weapframe14,sizeof(weapframe14));
		write(file,&weapframe15,sizeof(weapframe15));
		write(file,&weapframe16,sizeof(weapframe16));
		write(file,&weap1power,sizeof(weap1power));
		write(file,&weap2power,sizeof(weap2power));
		write(file,&weap3power,sizeof(weap3power));
		write(file,&weap4power,sizeof(weap4power));
		write(file,&maxammo1,sizeof(maxammo1));
		write(file,&startammo1,sizeof(startammo1));
		write(file,&maxhealth,sizeof(maxhealth));
		write(file,&guardhp1,sizeof(guardhp1));
		write(file,&guardhp2,sizeof(guardhp2));
		write(file,&guardhp3,sizeof(guardhp3));
		write(file,&guardhp4,sizeof(guardhp4));
		write(file,&guardspeed,sizeof(guardspeed));
		write(file,&guardpain,sizeof(guardpain));
		write(file,&guardacc,sizeof(guardacc));
		write(file,&guarddamage,sizeof(guarddamage));
		write(file,&guardpoints,sizeof(guardpoints));
		write(file,&sshp1,sizeof(sshp1));
		write(file,&sshp2,sizeof(sshp2));
		write(file,&sshp3,sizeof(sshp3));
		write(file,&sshp4,sizeof(sshp4));
		write(file,&ssspeed,sizeof(ssspeed));
		write(file,&sspain,sizeof(sspain));
		write(file,&ssacc,sizeof(ssacc));
		write(file,&ssdamage,sizeof(ssdamage));
		write(file,&sspoints,sizeof(sspoints));
		write(file,&officerhp1,sizeof(officerhp1));
		write(file,&officerhp2,sizeof(officerhp2));
		write(file,&officerhp3,sizeof(officerhp3));
		write(file,&officerhp4,sizeof(officerhp4));
		write(file,&officerspeed,sizeof(officerspeed));
		write(file,&officerpain,sizeof(officerpain));
		write(file,&officeracc,sizeof(officeracc));
		write(file,&officerdamage,sizeof(officerdamage));
		write(file,&officerpoints,sizeof(officerpoints));
		write(file,&doghp1,sizeof(doghp1));
		write(file,&doghp2,sizeof(doghp2));
		write(file,&doghp3,sizeof(doghp3));
		write(file,&doghp4,sizeof(doghp4));
		write(file,&dogspeed,sizeof(dogspeed));
		write(file,&dogacc,sizeof(dogacc));
		write(file,&dogdamage,sizeof(dogdamage));
		write(file,&dogpoints,sizeof(dogpoints));
		write(file,&mutanthp1,sizeof(mutanthp1));
		write(file,&mutanthp2,sizeof(mutanthp2));
		write(file,&mutanthp3,sizeof(mutanthp3));
		write(file,&mutanthp4,sizeof(mutanthp4));
		write(file,&mutantspeed,sizeof(mutantspeed));
		write(file,&mutantpain,sizeof(mutantpain));
		write(file,&mutantacc,sizeof(mutantacc));
		write(file,&mutantdamage,sizeof(mutantdamage));
		write(file,&mutantpoints,sizeof(mutantpoints));
		write(file,&hanshp1,sizeof(hanshp1));
		write(file,&hanshp2,sizeof(hanshp2));
		write(file,&hanshp3,sizeof(hanshp3));
		write(file,&hanshp4,sizeof(hanshp4));
		write(file,&hansspeed,sizeof(hansspeed));
		write(file,&hansacc,sizeof(hansacc));
		write(file,&hansdamage,sizeof(hansdamage));
		write(file,&hanspoints,sizeof(hanspoints));
		write(file,&schabbshp1,sizeof(schabbshp1));
		write(file,&schabbshp2,sizeof(schabbshp2));
		write(file,&schabbshp3,sizeof(schabbshp3));
		write(file,&schabbshp4,sizeof(schabbshp4));
		write(file,&schabbsspeed,sizeof(schabbsspeed));
		write(file,&schabbsacc,sizeof(schabbsacc));
		write(file,&schabbsdamage,sizeof(schabbsdamage));
		write(file,&schabbspoints,sizeof(schabbspoints));
		write(file,&fakehp1,sizeof(fakehp1));
		write(file,&fakehp2,sizeof(fakehp2));
		write(file,&fakehp3,sizeof(fakehp3));
		write(file,&fakehp4,sizeof(fakehp4));
		write(file,&fakespeed,sizeof(fakespeed));
		write(file,&fakeacc,sizeof(fakeacc));
		write(file,&fakedamage,sizeof(fakedamage));
		write(file,&fakepoints,sizeof(fakepoints));
		write(file,&mechahp1,sizeof(mechahp1));
		write(file,&mechahp2,sizeof(mechahp2));
		write(file,&mechahp3,sizeof(mechahp3));
		write(file,&mechahp4,sizeof(mechahp4));
		write(file,&mechaspeed,sizeof(mechaspeed));
		write(file,&mechaacc,sizeof(mechaacc));
		write(file,&mechadamage,sizeof(mechadamage));
		write(file,&mechapoints,sizeof(mechapoints));
		write(file,&hitlerhp1,sizeof(hitlerhp1));
		write(file,&hitlerhp2,sizeof(hitlerhp2));
		write(file,&hitlerhp3,sizeof(hitlerhp3));
		write(file,&hitlerhp4,sizeof(hitlerhp4));
		write(file,&hitlerspeed,sizeof(hitlerspeed));
		write(file,&hitleracc,sizeof(hitleracc));
		write(file,&hitlerdamage,sizeof(hitlerdamage));
		write(file,&hitlerpoints,sizeof(hitlerpoints));
		write(file,&gifthp1,sizeof(gifthp1));
		write(file,&gifthp2,sizeof(gifthp2));
		write(file,&gifthp3,sizeof(gifthp3));
		write(file,&gifthp4,sizeof(gifthp4));
		write(file,&giftspeed,sizeof(giftspeed));
		write(file,&giftacc,sizeof(giftacc));
		write(file,&giftdamage,sizeof(giftdamage));
		write(file,&giftpoints,sizeof(giftpoints));
		write(file,&gretelhp1,sizeof(gretelhp1));
		write(file,&gretelhp2,sizeof(gretelhp2));
		write(file,&gretelhp3,sizeof(gretelhp3));
		write(file,&gretelhp4,sizeof(gretelhp4));
		write(file,&gretelspeed,sizeof(gretelspeed));
		write(file,&gretelacc,sizeof(gretelacc));
		write(file,&greteldamage,sizeof(greteldamage));
		write(file,&gretelpoints,sizeof(gretelpoints));
		write(file,&fathp1,sizeof(fathp1));
		write(file,&fathp2,sizeof(fathp2));
		write(file,&fathp3,sizeof(fathp3));
		write(file,&fathp4,sizeof(fathp4));
		write(file,&fatspeed,sizeof(fatspeed));
		write(file,&fatacc,sizeof(fatacc));
		write(file,&fatdamage,sizeof(fatdamage));
		write(file,&fatpoints,sizeof(fatpoints));*/
		write(file,&seamlessness,sizeof(seamlessness));
		write(file,&seamlesslevels,sizeof(seamlesslevels));
		write(file,&weaptics,sizeof(weaptics));
		write(file,&weapattack,sizeof(weaptics));
		write(file,&weapframe,sizeof(weaptics));
		write(file,&higherweap,sizeof(higherweap));
		write(file,&ammonum,sizeof(ammonum));
		write(file,&ammotype,sizeof(ammotype));
		write(file,&weapenab,sizeof(weapenab));
		write(file,&weapstar,sizeof(weapstar));
		write(file,&starbest,sizeof(starbest));
		write(file,&ammomax,sizeof(ammomax));
		write(file,&ammostar,sizeof(ammostar));
		write(file,&weapimage,sizeof(weapimage));
		write(file,&weapaccur,sizeof(weapaccur));
		write(file,&weapdamag,sizeof(weapdamag));
		write(file,&weapsound,sizeof(weapsound));
		write(file,&weapkick,sizeof(weapkick));
		write(file,&weaprange,sizeof(weaprange));
		write(file,&silenced,sizeof(silenced));
		write(file,&weapimage,sizeof(weapimage));
		write(file,&damanoise,sizeof(damanoise));
		//write(file,&episode1tit,sizeof(episode1tit));
		//write(file,&episode1nam,sizeof(episode1nam));
		//write(file,&episode2tit,sizeof(episode2tit));
		//write(file,&episode2nam,sizeof(episode2nam));
		//write(file,&episode3tit,sizeof(episode3tit));
		//write(file,&episode3nam,sizeof(episode3nam));
		//write(file,&episode4tit,sizeof(episode4tit));
		//write(file,&episode4nam,sizeof(episode4nam));
		//write(file,&episode5tit,sizeof(episode5tit));
		//write(file,&episode5nam,sizeof(episode5nam));
		//write(file,&episode6tit,sizeof(episode6tit));
		//write(file,&episode6nam,sizeof(episode6nam));
		write(file,&piercing,sizeof(piercing));
		write(file,&misssped,sizeof(misssped));
		write(file,&firesped,sizeof(firesped));
		write(file,&missboom,sizeof(missboom));
		write(file,&fireboom,sizeof(fireboom));
		write(file,&missnorm,sizeof(misssped));
		write(file,&firenorm,sizeof(firenorm));
		write(file,&missplus,sizeof(missplus));
		write(file,&fireplus,sizeof(fireplus));
		write(file,&misssoun,sizeof(misssoun));
		write(file,&firesoun,sizeof(firesoun));
		write(file,&missexpl,sizeof(missexpl));
		write(file,&fireexpl,sizeof(fireexpl));
		write(file,&highres,sizeof(highres));

		close(file);
		}
	}
}


/*
====================
=
= ReadConfig
=
====================
*/

void ReadConfig(void)
{
	int                     file;
	SDMode          sd;
	SMMode          sm;
	SDSMode         sds;


	if ( (file = open(configname,O_BINARY | O_RDONLY)) != -1)
	{
	//
	// valid config file
	//
		read(file,Scores,sizeof(HighScore) * MaxScores);

		read(file,&sd,sizeof(sd));
		read(file,&sm,sizeof(sm));
		read(file,&sds,sizeof(sds));

		read(file,&mouseenabled,sizeof(mouseenabled));
		read(file,&joystickenabled,sizeof(joystickenabled));
		read(file,&joypadenabled,sizeof(joypadenabled));
		read(file,&joystickprogressive,sizeof(joystickprogressive));
		read(file,&joystickport,sizeof(joystickport));

		read(file,&dirscan,sizeof(dirscan));
		read(file,&buttonscan,sizeof(buttonscan));
		read(file,&buttonmouse,sizeof(buttonmouse));
		read(file,&buttonjoy,sizeof(buttonjoy));

		read(file,&viewsize,sizeof(viewsize));
		read(file,&mouseadjustment,sizeof(mouseadjustment));

		close(file);

		if (sd == sdm_AdLib && !AdLibPresent && !SoundBlasterPresent)
		{
			sd = sdm_PC;
			sd = smm_Off;
		}

		if ((sds == sds_SoundBlaster && !SoundBlasterPresent) ||
			(sds == sds_SoundSource && !SoundSourcePresent))
			sds = sds_Off;

		if (!MousePresent)
			mouseenabled = false;
		if (!JoysPresent[joystickport])
			joystickenabled = false;

		MainMenu[6].active=1;
		MainItems.curpos=0;
	}
	else
	{
	//
	// no config file, so select by hardware
	//
		if (SoundBlasterPresent || AdLibPresent)
		{
			sd = sdm_AdLib;
			sm = smm_AdLib;
		}
		else
		{
			sd = sdm_PC;
			sm = smm_Off;
		}

		if (SoundBlasterPresent)
			sds = sds_SoundBlaster;
		else if (SoundSourcePresent)
			sds = sds_SoundSource;
		else
			sds = sds_Off;

		if (MousePresent)
			mouseenabled = true;

		joystickenabled = false;
		joypadenabled = false;
		joystickport = 0;
		joystickprogressive = false;

		viewsize = 15;
		mouseadjustment=5;
	}

	SD_SetMusicMode (sm);
	SD_SetSoundMode (sd);
	SD_SetDigiDevice (sds);

}


/*
====================
=
= WriteConfig
=
====================
*/

void WriteConfig(void)
{
	int                     file;

	file = open(configname,O_CREAT | O_BINARY | O_WRONLY,
				S_IREAD | S_IWRITE | S_IFREG);

	if (file != -1)
	{
		write(file,Scores,sizeof(HighScore) * MaxScores);

		write(file,&SoundMode,sizeof(SoundMode));
		write(file,&MusicMode,sizeof(MusicMode));
		write(file,&DigiMode,sizeof(DigiMode));

		write(file,&mouseenabled,sizeof(mouseenabled));
		write(file,&joystickenabled,sizeof(joystickenabled));
		write(file,&joypadenabled,sizeof(joypadenabled));
		write(file,&joystickprogressive,sizeof(joystickprogressive));
		write(file,&joystickport,sizeof(joystickport));

		write(file,&dirscan,sizeof(dirscan));
		write(file,&buttonscan,sizeof(buttonscan));
		write(file,&buttonmouse,sizeof(buttonmouse));
		write(file,&buttonjoy,sizeof(buttonjoy));

		write(file,&viewsize,sizeof(viewsize));
		write(file,&mouseadjustment,sizeof(mouseadjustment));

		close(file);
	}
}


//===========================================================================


/*
========================
=
= Patch386
=
= Patch ldiv to use 32 bit instructions
=
========================
*/

char    *JHParmStrings[] = {"no386",nil};
void Patch386 (void)
{
extern void far jabhack2(void);
extern int far  CheckIs386(void);

	int     i;

	for (i = 1;i < _argc;i++)
		if (US_CheckParm(_argv[i],JHParmStrings) == 0)
		{
			IsA386 = false;
			return;
		}

	if (CheckIs386())
	{
		IsA386 = true;
		jabhack2();
	}
	else
		IsA386 = false;
}

//===========================================================================

/*
=====================
=
= NewGame
=
= Set up new game to start from the beginning
=
=====================
*/

void NewGame (int difficulty,int episode)
{
	memset (&gamestate,0,sizeof(gamestate));
	gamestate.difficulty = difficulty;
	gamestate.weapon = gamestate.bestweapon
		= gamestate.chosenweapon = starbest;
	gamestate.health = 100;
	gamestate.got1 = weapstar[0];
	gamestate.got2 = weapstar[1];
	gamestate.got3 = weapstar[2];
	gamestate.got4 = weapstar[3];
	gamestate.got5 = weapstar[4];
	gamestate.got6 = weapstar[5];
	gamestate.got7 = weapstar[6];
	gamestate.got8 = weapstar[7];
	gamestate.got9 = weapstar[8];
	gamestate.got10 = weapstar[9];
	gamestate.ammo[0] = 1;
	gamestate.ammo[1] = ammostar[1];
	gamestate.ammo[2] = ammostar[2];
	gamestate.ammo[3] = ammostar[3];
	gamestate.ammo[4] = ammostar[4];
	gamestate.ammo[5] = ammostar[5];
	gamestate.ammo[6] = ammostar[6];
	gamestate.ammo[7] = ammostar[7];
	gamestate.ammo[8] = ammostar[8];
	gamestate.ammo[9] = ammostar[9];
	gamestate.lives = 3;
	gamestate.nextextra = EXTRAPOINTS;
	gamestate.episode=episode;
	gamestate.lastammo = ammotype[gamestate.weapon];

	startgame = true;
}

//===========================================================================

void DiskFlopAnim(int x,int y)
{
 static char which=0;
 if (!x && !y)
   return;
 VWB_DrawPic(x,y,C_DISKLOADING1PIC+which);
 VW_UpdateScreen();
 which^=1;
}


long DoChecksum(byte far *source,unsigned size,long checksum)
{
 unsigned i;

 for (i=0;i<size-1;i++)
   checksum += source[i]^source[i+1];

 return checksum;
}


/*
==================
=
= SaveTheGame
=
==================
*/

boolean SaveTheGame(int file,int x,int y)
{
	struct diskfree_t dfree;
	long avail,size,checksum;
	objtype *ob,nullobj;


	if (_dos_getdiskfree(0,&dfree))
	  Quit("Error in _dos_getdiskfree call");

	avail = (long)dfree.avail_clusters *
			dfree.bytes_per_sector *
			dfree.sectors_per_cluster;

	size = 0;
	for (ob = player; ob ; ob=ob->next)
	  size += sizeof(*ob);
	size += sizeof(nullobj);

	size += sizeof(gamestate) +
			sizeof(LRstruct)*8 +
			sizeof(tilemap) +
			sizeof(actorat) +
			sizeof(laststatobj) +
			sizeof(statobjlist) +
			sizeof(doorposition) +
			sizeof(pwallstate) +
			sizeof(pwallx) +
			sizeof(pwally) +
			sizeof(pwalldir) +
			sizeof(pwallpos);

	if (avail < size)
	{
	 Message(STR_NOSPACE1"\n"
			 STR_NOSPACE2);
	 return false;
	}

	checksum = 0;


	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)&gamestate,sizeof(gamestate));
	checksum = DoChecksum((byte far *)&gamestate,sizeof(gamestate),checksum);

	DiskFlopAnim(x,y);
#ifdef SPEAR
	CA_FarWrite (file,(void far *)&LevelRatios[0],sizeof(LRstruct)*20);
	checksum = DoChecksum((byte far *)&LevelRatios[0],sizeof(LRstruct)*20,checksum);
#else
	CA_FarWrite (file,(void far *)&LevelRatios[0],sizeof(LRstruct)*8);
	checksum = DoChecksum((byte far *)&LevelRatios[0],sizeof(LRstruct)*8,checksum);
#endif

	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)tilemap,sizeof(tilemap));
	checksum = DoChecksum((byte far *)tilemap,sizeof(tilemap),checksum);
	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)actorat,sizeof(actorat));
	checksum = DoChecksum((byte far *)actorat,sizeof(actorat),checksum);

	CA_FarWrite (file,(void far *)areaconnect,sizeof(areaconnect));
	CA_FarWrite (file,(void far *)areabyplayer,sizeof(areabyplayer));

	for (ob = player ; ob ; ob=ob->next)
	{
	 DiskFlopAnim(x,y);
	 CA_FarWrite (file,(void far *)ob,sizeof(*ob));
	}
	nullobj.active = ac_badobject;          // end of file marker
	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)&nullobj,sizeof(nullobj));



	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)&laststatobj,sizeof(laststatobj));
	checksum = DoChecksum((byte far *)&laststatobj,sizeof(laststatobj),checksum);
	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)statobjlist,sizeof(statobjlist));
	checksum = DoChecksum((byte far *)statobjlist,sizeof(statobjlist),checksum);

	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)doorposition,sizeof(doorposition));
	checksum = DoChecksum((byte far *)doorposition,sizeof(doorposition),checksum);
	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)doorobjlist,sizeof(doorobjlist));
	checksum = DoChecksum((byte far *)doorobjlist,sizeof(doorobjlist),checksum);

	DiskFlopAnim(x,y);
	CA_FarWrite (file,(void far *)&pwallstate,sizeof(pwallstate));
	checksum = DoChecksum((byte far *)&pwallstate,sizeof(pwallstate),checksum);
	CA_FarWrite (file,(void far *)&pwallx,sizeof(pwallx));
	checksum = DoChecksum((byte far *)&pwallx,sizeof(pwallx),checksum);
	CA_FarWrite (file,(void far *)&pwally,sizeof(pwally));
	checksum = DoChecksum((byte far *)&pwally,sizeof(pwally),checksum);
	CA_FarWrite (file,(void far *)&pwalldir,sizeof(pwalldir));
	checksum = DoChecksum((byte far *)&pwalldir,sizeof(pwalldir),checksum);
	CA_FarWrite (file,(void far *)&pwallpos,sizeof(pwallpos));
	checksum = DoChecksum((byte far *)&pwallpos,sizeof(pwallpos),checksum);

	//
	// WRITE OUT CHECKSUM
	//
	CA_FarWrite (file,(void far *)&checksum,sizeof(checksum));

	return(true);
}

//===========================================================================

/*
==================
=
= LoadTheGame
=
==================
*/

boolean LoadTheGame(int file,int x,int y)
{
	long checksum,oldchecksum;
	objtype *ob,nullobj;


	checksum = 0;

	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)&gamestate,sizeof(gamestate));
	checksum = DoChecksum((byte far *)&gamestate,sizeof(gamestate),checksum);

	DiskFlopAnim(x,y);
#ifdef SPEAR
	CA_FarRead (file,(void far *)&LevelRatios[0],sizeof(LRstruct)*20);
	checksum = DoChecksum((byte far *)&LevelRatios[0],sizeof(LRstruct)*20,checksum);
#else
	CA_FarRead (file,(void far *)&LevelRatios[0],sizeof(LRstruct)*8);
	checksum = DoChecksum((byte far *)&LevelRatios[0],sizeof(LRstruct)*8,checksum);
#endif

	DiskFlopAnim(x,y);
	SetupGameLevel ();

	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)tilemap,sizeof(tilemap));
	checksum = DoChecksum((byte far *)tilemap,sizeof(tilemap),checksum);
	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)actorat,sizeof(actorat));
	checksum = DoChecksum((byte far *)actorat,sizeof(actorat),checksum);

	CA_FarRead (file,(void far *)areaconnect,sizeof(areaconnect));
	CA_FarRead (file,(void far *)areabyplayer,sizeof(areabyplayer));



	InitActorList ();
	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)player,sizeof(*player));

	while (1)
	{
	 DiskFlopAnim(x,y);
		CA_FarRead (file,(void far *)&nullobj,sizeof(nullobj));
		if (nullobj.active == ac_badobject)
			break;
		GetNewActor ();
	 // don't copy over the links
		memcpy (new,&nullobj,sizeof(nullobj)-4);
	}



	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)&laststatobj,sizeof(laststatobj));
	checksum = DoChecksum((byte far *)&laststatobj,sizeof(laststatobj),checksum);
	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)statobjlist,sizeof(statobjlist));
	checksum = DoChecksum((byte far *)statobjlist,sizeof(statobjlist),checksum);

	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)doorposition,sizeof(doorposition));
	checksum = DoChecksum((byte far *)doorposition,sizeof(doorposition),checksum);
	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)doorobjlist,sizeof(doorobjlist));
	checksum = DoChecksum((byte far *)doorobjlist,sizeof(doorobjlist),checksum);

	DiskFlopAnim(x,y);
	CA_FarRead (file,(void far *)&pwallstate,sizeof(pwallstate));
	checksum = DoChecksum((byte far *)&pwallstate,sizeof(pwallstate),checksum);
	CA_FarRead (file,(void far *)&pwallx,sizeof(pwallx));
	checksum = DoChecksum((byte far *)&pwallx,sizeof(pwallx),checksum);
	CA_FarRead (file,(void far *)&pwally,sizeof(pwally));
	checksum = DoChecksum((byte far *)&pwally,sizeof(pwally),checksum);
	CA_FarRead (file,(void far *)&pwalldir,sizeof(pwalldir));
	checksum = DoChecksum((byte far *)&pwalldir,sizeof(pwalldir),checksum);
	CA_FarRead (file,(void far *)&pwallpos,sizeof(pwallpos));
	checksum = DoChecksum((byte far *)&pwallpos,sizeof(pwallpos),checksum);

	CA_FarRead (file,(void far *)&oldchecksum,sizeof(oldchecksum));

	if (oldchecksum != checksum)
	{
	 Message(STR_SAVECHT1"\n"
			 STR_SAVECHT2"\n"
			 STR_SAVECHT3"\n"
			 STR_SAVECHT4);

	 IN_ClearKeysDown();
	 IN_Ack();

	 gamestate.score = 0;
	 gamestate.lives = 1;
	 gamestate.weapon =
	   gamestate.chosenweapon =
	   gamestate.bestweapon = wp_pistol;
	 gamestate.ammo[1] = 8;
	}

	return true;
}

//===========================================================================

/*
==========================
=
= ShutdownId
=
= Shuts down all ID_?? managers
=
==========================
*/

void ShutdownId (void)
{
	US_Shutdown ();
	SD_Shutdown ();
	PM_Shutdown ();
	IN_Shutdown ();
	VW_Shutdown ();
	CA_Shutdown ();
	MM_Shutdown ();
}


//===========================================================================

/*
==================
=
= BuildTables
=
= Calculates:
=
= scale                 projection constant
= sintable/costable     overlapping fractional tables
=
==================
*/

const   float   radtoint = (float)FINEANGLES/2/PI;

void BuildTables (void)
{
  int           i;
  float         angle,anglestep;
  double        tang;
  fixed         value;


//
// calculate fine tangents
//

	for (i=0;i<FINEANGLES/8;i++)
	{
		tang = tan( (i+0.5)/radtoint);
		finetangent[i] = tang*TILEGLOBAL;
		finetangent[FINEANGLES/4-1-i] = 1/tang*TILEGLOBAL;
	}

//
// costable overlays sintable with a quarter phase shift
// ANGLES is assumed to be divisable by four
//
// The low word of the value is the fraction, the high bit is the sign bit,
// bits 16-30 should be 0
//

  angle = 0;
  anglestep = PI/2/ANGLEQUAD;
  for (i=0;i<=ANGLEQUAD;i++)
  {
	value=GLOBAL1*sin(angle);
	sintable[i]=
	  sintable[i+ANGLES]=
	  sintable[ANGLES/2-i] = value;
	sintable[ANGLES-i]=
	  sintable[ANGLES/2+i] = value | 0x80000000l;
	angle += anglestep;
  }

}

//===========================================================================


/*
====================
=
= CalcProjection
=
= Uses focallength
=
====================
*/

void CalcProjection (long focal)
{
	int             i;
	long            intang;
	float   angle;
	double  tang;
	double  planedist;
	double  globinhalf;
	int             halfview;
	double  halfangle,facedist;


	focallength = focal;
	facedist = focal+MINDIST;
	halfview = viewwidth/2;                                 // half view in pixels

//
// calculate scale value for vertical height calculations
// and sprite x calculations
//
	scale = halfview*facedist/(VIEWGLOBAL/2);

//
// divide heightnumerator by a posts distance to get the posts height for
// the heightbuffer.  The pixel height is height>>2
//
	heightnumerator = (TILEGLOBAL*scale)>>6;
	minheightdiv = heightnumerator/0x7fff +1;

//
// calculate the angle offset from view angle of each pixel's ray
//

	for (i=0;i<halfview;i++)
	{
	// start 1/2 pixel over, so viewangle bisects two middle pixels
		tang = (long)i*VIEWGLOBAL/viewwidth/facedist;
		angle = atan(tang);
		intang = angle*radtoint;
		pixelangle[halfview-1-i] = intang;
		pixelangle[halfview+i] = -intang;
	}

//
// if a point's abs(y/x) is greater than maxslope, the point is outside
// the view area
//
	maxslope = finetangent[pixelangle[0]];
	maxslope >>= 8;
}



//===========================================================================

/*
===================
=
= SetupWalls
=
= Map tile values to scaled pics
=
===================
*/

void SetupWalls (void)
{
	int     i;

	for (i=1;i<MAXWALLTILES;i++)
	{
		horizwall[i]=(i-1)*2;
		vertwall[i]=(i-1)*2+1;
	}
}

//===========================================================================

/*
==========================
=
= SignonScreen
=
==========================
*/

void SignonScreen (void)                        // VGA version
{
	unsigned        segstart,seglength;

	VL_SetVGAPlaneMode ();
	VL_TestPaletteSet ();
	VL_SetPalette (&gamepal);

	if (!virtualreality)
	{
		VW_SetScreen(0x8000,0);
		VL_MungePic (&introscn,320,200);
		VL_MemToScreen (&introscn,320,200,0,0);
		VW_SetScreen(0,0);
	}

//
// reclaim the memory from the linked in signon screen
//
	segstart = FP_SEG(&introscn);
	seglength = 64000/16;
	if (FP_OFF(&introscn))
	{
		segstart++;
		seglength--;
	}
	MML_UseSpace (segstart,seglength);
}


/*
==========================
=
= FinishSignon
=
==========================
*/

void FinishSignon (void)
{

#ifndef SPEAR
	VW_Bar (0,189,300,11,peekb(0xa000,0));
	WindowX = 0;
	WindowW = 320;
	PrintY = 190;

	#ifndef JAPAN
	SETFONTCOLOR(14,4);

	#ifdef SPANISH
	US_CPrint ("Oprima una tecla");
	#else
	US_CPrint ("Press a key");
	#endif

	#endif

	if (!NoWait)
		IN_Ack ();

	#ifndef JAPAN
	VW_Bar (0,189,300,11,peekb(0xa000,0));

	PrintY = 190;
	SETFONTCOLOR(10,4);

	#ifdef SPANISH
	US_CPrint ("pensando...");
	#else
	US_CPrint ("Working...");
	#endif

	#endif

	SETFONTCOLOR(0,15);
#else
	if (!NoWait)
		VW_WaitVBL(3*70);
#endif
}

//===========================================================================

/*
=================
=
= MS_CheckParm
=
=================
*/

boolean MS_CheckParm (char far *check)
{
	int             i;
	char    *parm;

	for (i = 1;i<_argc;i++)
	{
		parm = _argv[i];

		while ( !isalpha(*parm) )       // skip - / \ etc.. in front of parm
			if (!*parm++)
				break;                          // hit end of string without an alphanum

		if ( !_fstricmp(check,parm) )
			return true;
	}

	return false;
}

//===========================================================================

/*
=====================
=
= InitDigiMap
=
=====================
*/

static  int     wolfdigimap[] =
		{
			// These first sounds are in the upload version
#ifndef SPEAR
			HALTSND,                0,
			DOGBARKSND,             1,
			CLOSEDOORSND,           2,
			OPENDOORSND,            3,
			ATKMACHINEGUNSND,       4,
			ATKPISTOLSND,           5,
			ATKGATLINGSND,          6,
			SCHUTZADSND,            7,
			GUTENTAGSND,            8,
			MUTTISND,               9,
			BOSSFIRESND,            10,
			SSFIRESND,              11,
			DEATHSCREAM1SND,        12,
			DEATHSCREAM2SND,        13,
			DEATHSCREAM3SND,        13,
			TAKEDAMAGESND,          14,
			PUSHWALLSND,            15,

			LEBENSND,               20,
			NAZIFIRESND,            21,
			SLURPIESND,             22,

			YEAHSND,				32,

#ifndef UPLOAD
			// These are in all other episodes
			DOGDEATHSND,            16,
			AHHHGSND,               17,
			DIESND,                 18,
			EVASND,                 19,

			TOT_HUNDSND,            23,
			MEINGOTTSND,            24,
			SCHABBSHASND,           25,
			HITLERHASND,            26,
			SPIONSND,               27,
			NEINSOVASSND,           28,
			DOGATTACKSND,           29,
			LEVELDONESND,           30,
			MECHSTEPSND,			31,

			SCHEISTSND,				33,
			DEATHSCREAM4SND,		34,		// AIIEEE
			DEATHSCREAM5SND,		35,		// DEE-DEE
			DONNERSND,				36,		// EPISODE 4 BOSS DIE
			EINESND,				37,		// EPISODE 4 BOSS SIGHTING
			ERLAUBENSND,			38,		// EPISODE 6 BOSS SIGHTING
			DEATHSCREAM6SND,		39,		// FART
			DEATHSCREAM7SND,		40,		// GASP
			DEATHSCREAM8SND,		41,		// GUH-BOY!
			DEATHSCREAM9SND,		42,		// AH GEEZ!
			KEINSND,				43,		// EPISODE 5 BOSS SIGHTING
			MEINSND,				44,		// EPISODE 6 BOSS DIE
			ROSESND,				45,		// EPISODE 5 BOSS DIE

#endif
#else
//
// SPEAR OF DESTINY DIGISOUNDS
//
			HALTSND,                0,
			CLOSEDOORSND,           2,
			OPENDOORSND,            3,
			ATKMACHINEGUNSND,       4,
			ATKPISTOLSND,           5,
			ATKGATLINGSND,          6,
			SCHUTZADSND,            7,
			BOSSFIRESND,            8,
			SSFIRESND,              9,
			DEATHSCREAM1SND,        10,
			DEATHSCREAM2SND,        11,
			TAKEDAMAGESND,          12,
			PUSHWALLSND,            13,
			AHHHGSND,               15,
			LEBENSND,               16,
			NAZIFIRESND,            17,
			SLURPIESND,             18,
			LEVELDONESND,           22,
			DEATHSCREAM4SND,		23,		// AIIEEE
			DEATHSCREAM3SND,        23,		// DOUBLY-MAPPED!!!
			DEATHSCREAM5SND,		24,		// DEE-DEE
			DEATHSCREAM6SND,		25,		// FART
			DEATHSCREAM7SND,		26,		// GASP
			DEATHSCREAM8SND,		27,		// GUH-BOY!
			DEATHSCREAM9SND,		28,		// AH GEEZ!
			GETGATLINGSND,			38,		// Got Gat replacement

#ifndef SPEARDEMO
			DOGBARKSND,             1,
			DOGDEATHSND,            14,
			SPIONSND,               19,
			NEINSOVASSND,           20,
			DOGATTACKSND,           21,
			TRANSSIGHTSND,			29,		// Trans Sight
			TRANSDEATHSND,			30,		// Trans Death
			WILHELMSIGHTSND,		31,		// Wilhelm Sight
			WILHELMDEATHSND,		32,		// Wilhelm Death
			UBERDEATHSND,			33,		// Uber Death
			KNIGHTSIGHTSND,			34,		// Death Knight Sight
			KNIGHTDEATHSND,			35,		// Death Knight Death
			ANGELSIGHTSND,			36,		// Angel Sight
			ANGELDEATHSND,			37,		// Angel Death
			GETSPEARSND,			39,		// Got Spear replacement
#endif
#endif
			LASTSOUND
		};


void InitDigiMap (void)
{
	int                     *map;

	for (map = wolfdigimap;*map != LASTSOUND;map += 2)
		DigiMap[map[0]] = map[1];


}


#ifndef SPEAR
CP_iteminfo	MusicItems={CTL_X,CTL_Y,6,0,32};
CP_itemtype far MusicMenu[]=
	{
		{1,"Get Them!",0},
		{1,"Searching",0},
		{1,"P.O.W.",0},
		{1,"Suspense",0},
		{1,"War March",0},
		{1,"Around The Corner!",0},

		{1,"Nazi Anthem",0},
		{1,"Lurking...",0},
		{1,"Going After Hitler",0},
		{1,"Pounding Headache",0},
		{1,"Into the Dungeons",0},
		{1,"Ultimate Conquest",0},

		{1,"Kill the S.O.B.",0},
		{1,"The Nazi Rap",0},
		{1,"Twelfth Hour",0},
		{1,"Zero Hour",0},
		{1,"Ultimate Conquest",0},
		{1,"Wolfpack",0}
	};
#else
CP_iteminfo MusicItems={CTL_X,CTL_Y-20,9,0,32};
CP_itemtype far MusicMenu[]=
   {
		{1,"Funky Colonel Bill",0},
		{1,"Death To The Nazis",0},
		{1,"Tiptoeing Around",0},
		{1,"Is This THE END?",0},
		{1,"Evil Incarnate",0},
		{1,"Jazzin' Them Nazis",0},
		{1,"Puttin' It To The Enemy",0},
		{1,"The SS Gonna Get You",0},
		{1,"Towering Above",0}
	};
#endif

#ifndef SPEARDEMO
void DoJukebox(void)
{
	int which,lastsong=-1;
	unsigned start,songs[]=
		{
#ifndef SPEAR
			GETTHEM_MUS,
			SEARCHN_MUS,
			POW_MUS,
			SUSPENSE_MUS,
			WARMARCH_MUS,
			CORNER_MUS,

			NAZI_OMI_MUS,
			PREGNANT_MUS,
			GOINGAFT_MUS,
			HEADACHE_MUS,
			DUNGEON_MUS,
			ULTIMATE_MUS,

			INTROCW3_MUS,
			NAZI_RAP_MUS,
			TWELFTH_MUS,
			ZEROHOUR_MUS,
			ULTIMATE_MUS,
			PACMAN_MUS
#else
			XFUNKIE_MUS,             // 0
			XDEATH_MUS,              // 2
			XTIPTOE_MUS,             // 4
			XTHEEND_MUS,             // 7
			XEVIL_MUS,               // 17
			XJAZNAZI_MUS,            // 18
			XPUTIT_MUS,              // 21
			XGETYOU_MUS,             // 22
			XTOWER2_MUS              // 23
#endif
		};
	struct dostime_t time;



	IN_ClearKeysDown();
	if (!AdLibPresent && !SoundBlasterPresent)
		return;


	MenuFadeOut();

#ifndef SPEAR
#ifndef UPLOAD
	_dos_gettime(&time);
	start = (time.hsecond%3)*6;
#else
	start = 0;
#endif
#else
	start = 0;
#endif


	CA_CacheGrChunk (STARTFONT+1);
#ifdef SPEAR
	CacheLump (BACKDROP_LUMP_START,BACKDROP_LUMP_END);
#else
	CacheLump (CONTROLS_LUMP_START,CONTROLS_LUMP_END);
#endif
	CA_LoadAllSounds ();

	fontnumber=1;
	ClearMScreen ();
	VWB_DrawPic(112,184,C_MOUSELBACKPIC);
	DrawStripes (10);
	SETFONTCOLOR (TEXTCOLOR,BKGDCOLOR);

#ifndef SPEAR
	DrawWindow (CTL_X-2,CTL_Y-6,280,13*7,BKGDCOLOR);
#else
	DrawWindow (CTL_X-2,CTL_Y-26,280,13*10,BKGDCOLOR);
#endif

	DrawMenu (&MusicItems,&MusicMenu[start]);

	SETFONTCOLOR (READHCOLOR,BKGDCOLOR);
	PrintY=15;
	WindowX = 0;
	WindowY = 320;
	US_CPrint ("Robert's Jukebox");

	SETFONTCOLOR (TEXTCOLOR,BKGDCOLOR);
	VW_UpdateScreen();
	MenuFadeIn();

	do
	{
		which = HandleMenu(&MusicItems,&MusicMenu[start],NULL);
		if (which>=0)
		{
			if (lastsong >= 0)
				MusicMenu[start+lastsong].active = 1;

			StartCPMusic(songs[start + which]);
			MusicMenu[start+which].active = 2;
			DrawMenu (&MusicItems,&MusicMenu[start]);
			VW_UpdateScreen();
			lastsong = which;
		}
	} while(which>=0);

	MenuFadeOut();
	IN_ClearKeysDown();
#ifdef SPEAR
	UnCacheLump (BACKDROP_LUMP_START,BACKDROP_LUMP_END);
#else
	UnCacheLump (CONTROLS_LUMP_START,CONTROLS_LUMP_END);
#endif
}
#endif


/*
==========================
=
= InitGame
=
= Load a few things right away
=
==========================
*/

void InitGame (void)
{
	int                     i,x,y;
	unsigned        *blockstart;

	if (MS_CheckParm ("virtual"))
		virtualreality = true;
	else
		virtualreality = false;

	MM_Startup ();                  // so the signon screen can be freed

	SignonScreen ();

	VW_Startup ();
	IN_Startup ();
	PM_Startup ();
	PM_UnlockMainMem ();
	SD_Startup ();
	CA_Startup ();
	US_Startup ();


#ifndef SPEAR
	if (mminfo.mainmem < 235000L)
#else
	if (mminfo.mainmem < 257000L && !MS_CheckParm("debugmode"))
#endif
	{
		memptr screen;

		CA_CacheGrChunk (ERRORSCREEN);
		screen = grsegs[ERRORSCREEN];
		ShutdownId();
		movedata ((unsigned)screen,7+7*160,0xb800,0,17*160);
		gotoxy (1,23);
		exit(1);
	}


//
// build some tables
//
	InitDigiMap ();

	for (i=0;i<MAPSIZE;i++)
	{
		nearmapylookup[i] = &tilemap[0][0]+MAPSIZE*i;
		farmapylookup[i] = i*64;
	}

	for (i=0;i<PORTTILESHIGH;i++)
		uwidthtable[i] = UPDATEWIDE*i;

	blockstart = &blockstarts[0];
	for (y=0;y<UPDATEHIGH;y++)
		for (x=0;x<UPDATEWIDE;x++)
			*blockstart++ = SCREENWIDTH*16*y+x*TILEWIDTH;

	updateptr = &update[0];

	bufferofs = 0;
	displayofs = 0;
	ReadConfig ();
	ReadGame ();


//
// HOLDING DOWN 'M' KEY?
//
#ifndef SPEARDEMO
	if (Keyboard[sc_M])
	  DoJukebox();
	else
#endif
//
// draw intro screen stuff
//
	if (!virtualreality)
		IntroScreen ();

//
// load in and lock down some basic chunks
//

	CA_CacheGrChunk(STARTFONT);
	MM_SetLock (&grsegs[STARTFONT],true);

	LoadLatchMem ();
	BuildTables ();          // trig tables
	SetupWalls ();

#if 0
{
int temp,i;
temp = viewsize;
	profilehandle = open("SCALERS.TXT", O_CREAT | O_WRONLY | O_TEXT);
for (i=1;i<20;i++)
	NewViewSize(i);
viewsize = temp;
close(profilehandle);
}
#endif

	NewViewSize (viewsize);


//
// initialize variables
//
	InitRedShifts ();
	if (!virtualreality)
		FinishSignon();

	displayofs = PAGE1START;
	bufferofs = PAGE2START;

	if (virtualreality)
	{
		NoWait = true;
		geninterrupt(0x60);
	}
}

//===========================================================================

/*
==========================
=
= SetViewSize
=
==========================
*/

boolean SetViewSize (unsigned width, unsigned height)
{
	viewwidth = width&~15;                  // must be divisable by 16
	viewheight = height&~1;                 // must be even
	centerx = viewwidth/2-1;
	shootdelta = viewwidth/10;
	screenofs = ((200-STATUSLINES-viewheight)/2*SCREENWIDTH+(320-viewwidth)/8);

//
// calculate trace angles and projection constants
//
	CalcProjection (FOCALLENGTH);

//
// build all needed compiled scalers
//
//	MM_BombOnError (false);
	SetupScaling (viewwidth*1.5);
#if 0
	MM_BombOnError (true);
	if (mmerror)
	{
		Quit ("Can't build scalers!");
		mmerror = false;
		return false;
	}
#endif
	return true;
}


void ShowViewSize (int width)
{
	int     oldwidth,oldheight;

	oldwidth = viewwidth;
	oldheight = viewheight;

	viewwidth = width*16;
	viewheight = width*16*HEIGHTRATIO;
	DrawPlayBorder ();

	viewheight = oldheight;
	viewwidth = oldwidth;
}


void NewViewSize (int width)
{
	CA_UpLevel ();
	MM_SortMem ();
	viewsize = width;
	SetViewSize (width*16,width*16*HEIGHTRATIO);
	CA_DownLevel ();
}



//===========================================================================

/*
==========================
=
= Quit
=
==========================
*/

void Quit (char *error)
{
	unsigned        finscreen;
	memptr	screen;

	if (virtualreality)
		geninterrupt(0x61);

	ClearMemory ();
	if (!*error)
	{
	 #ifndef JAPAN
	 CA_CacheGrChunk (ORDERSCREEN);
	 screen = grsegs[ORDERSCREEN];
	 #endif
	 WriteConfig ();
	}
	else
	{
	 CA_CacheGrChunk (ERRORSCREEN);
	 screen = grsegs[ERRORSCREEN];
	}

	ShutdownId ();

	if (error && *error)
	{
	  movedata ((unsigned)screen,7,0xb800,0,7*160);
	  gotoxy (10,4);
	  puts(error);
	  gotoxy (1,8);
	  exit(1);
	}
	else
	if (!error || !(*error))
	{
		clrscr();
		#ifndef JAPAN
		movedata ((unsigned)screen,7,0xb800,0,4000);
		gotoxy(1,24);
		#endif
//asm	mov	bh,0
//asm	mov	dh,23	// row
//asm	mov	dl,0	// collumn
//asm	mov ah,2
//asm	int	0x10
	}

	exit(0);
}

//===========================================================================



/*
=====================
=
= DemoLoop
=
=====================
*/

static  char *ParmStrings[] = {"baby","easy","normal","hard",""};

void    DemoLoop (void)
{
	static int LastDemo;
	int     i,level;
	long nsize;
	memptr	nullblock;

//
// check for launch from ted
//
	if (tedlevel)
	{
		NoWait = true;
		NewGame(1,0);

		for (i = 1;i < _argc;i++)
		{
			if ( (level = US_CheckParm(_argv[i],ParmStrings)) != -1)
			{
			 gamestate.difficulty=level;
			 break;
			}
		}

#ifndef SPEAR
		gamestate.episode = tedlevelnum/10;
		gamestate.mapon = tedlevelnum%10;
#else
		gamestate.episode = 0;
		gamestate.mapon = tedlevelnum;
#endif
		GameLoop();
		Quit (NULL);
	}


//
// main game cycle
//


//	nsize = (long)40*1024;
//	MM_GetPtr(&nullblock,nsize);

#ifndef DEMOTEST

	#ifndef UPLOAD

		#ifndef GOODTIMES
		#ifndef SPEAR
		#ifndef JAPAN
		if (!NoWait)
			NonShareware();
		#endif
		#else

			#ifndef GOODTIMES
			#ifndef SPEARDEMO
			CopyProtection();
			#endif
			#endif

		#endif
		#endif
	#endif

	StartCPMusic(INTROSONG);

#ifndef JAPAN
	if (!NoWait)
		PG13 ();
#endif

#endif

	while (1)
	{
		while (!NoWait)
		{
//
// title page
//
			MM_SortMem ();
#ifndef DEMOTEST

#ifdef SPEAR
			CA_CacheGrChunk (TITLEPALETTE);

			CA_CacheGrChunk (TITLE1PIC);
			VWB_DrawPic (0,0,TITLE1PIC);
			UNCACHEGRCHUNK (TITLE1PIC);

			CA_CacheGrChunk (TITLE2PIC);
			VWB_DrawPic (0,80,TITLE2PIC);
			UNCACHEGRCHUNK (TITLE2PIC);
			VW_UpdateScreen ();
			VL_FadeIn(0,255,grsegs[TITLEPALETTE],30);

			UNCACHEGRCHUNK (TITLEPALETTE);
#else
			CA_CacheScreen (TITLEPIC);
			VW_UpdateScreen ();
			VW_FadeIn();
#endif
			if (IN_UserInput(TickBase*15))
				break;
			VW_FadeOut();
//
// credits page
//
			CA_CacheScreen (CREDITSPIC);
			VW_UpdateScreen();
			VW_FadeIn ();
			if (IN_UserInput(TickBase*10))
				break;
			VW_FadeOut ();
//
// high scores
//
			DrawHighScores ();
			VW_UpdateScreen ();
			VW_FadeIn ();

			if (IN_UserInput(TickBase*10))
				break;
#endif
//
// demo
//

			#ifndef SPEARDEMO
			PlayDemo (LastDemo++%4);
			#else
			PlayDemo (0);
			#endif

			if (playstate == ex_abort)
				break;
			StartCPMusic(INTROSONG);
		}

		VW_FadeOut ();

#ifndef SPEAR
		if (Keyboard[sc_Tab] && MS_CheckParm("goobers"))
#else
		if (Keyboard[sc_Tab] && MS_CheckParm("debugmode"))
#endif
			RecordDemo ();
		else
			US_ControlPanel (0);

		if (startgame || loadedgame)
		{
			GameLoop ();
			VW_FadeOut();
			StartCPMusic(INTROSONG);
		}
	}
}


//===========================================================================


/*
==========================
=
= main
=
==========================
*/

char    *nosprtxt[] = {"nospr",nil};

void main (void)
{
	int     i;


#ifdef BETA
	//
	// THIS IS FOR BETA ONLY!
	//
	struct dosdate_t d;

	_dos_getdate(&d);
	if (d.year > YEAR ||
		(d.month >= MONTH && d.day >= DAY))
	{
	 printf("Sorry, BETA-TESTING is over. Thanks for you help.\n");
	 exit(1);
	}
#endif

	CheckForEpisodes();

	Patch386 ();

	InitGame ();

	DemoLoop();

	Quit("Demo loop exited???");
}

